/* UFO Extender - Mod for X-COM
 * See <http://www.ufopaedia.org/index.php?title=User:Seb76> for more details.
 * Copyright (C) 2008 Seb76
 *
 * This file is part of UFO Extender.

 * UFO Extender is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * UFO Extender is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with UFO Extender.  If not, see <http://www.gnu.org/licenses/>.
 */


#include "stdafx.h"

#ifdef NDEBUG
#define PROC_NAME "UFO Defense.exe" 
#else
#define PROC_NAME "C:\\Documents and Settings\\Gondos\\Bureau\\UFO - Enemy Unknown\\UFO Defense.exe" 
#endif

#define INI_FILE "./UFOExtender.ini"
#define INI_READ_STRING(section,key,default,buf,size) GetPrivateProfileStringA(section,key,default,buf,size,INI_FILE)
#define INI_READ_INT(section,key,default) GetPrivateProfileIntA(section,key,default,INI_FILE)

DWORD DebugLoop();
PROCESS_INFORMATION piProcessInfo;

int __stdcall WinMain(HINSTANCE /*i*/, HINSTANCE /*p*/,LPSTR cmd,int /*s*/)
{
	HANDLE hThread;
	STARTUPINFOA siStartupInfo;
	DWORD exitCode;
	char procnameBuf[MAX_PATH];
	char *procname=procnameBuf;
	char *cmdline=NULL;
	void *pLibRemote;
	memset(&siStartupInfo, 0, sizeof(siStartupInfo));
	memset(&piProcessInfo, 0, sizeof(piProcessInfo));
	siStartupInfo.cb = sizeof(siStartupInfo);

	if(strlen(cmd)>0)
	{
		cmdline=cmd;
		procname=NULL;
	}
	else
	{
		INI_READ_STRING("Loader","Executable",PROC_NAME,procname,MAX_PATH);
	}

	CreateProcessA(procname,
						  cmdline, 0, 0, false,
#ifdef NDEBUG
						  CREATE_SUSPENDED , 0, NULL,
#else
						  CREATE_SUSPENDED , 0, "C:\\Documents and Settings\\Gondos\\Bureau\\UFO - Enemy Unknown",
#endif
						  &siStartupInfo, &piProcessInfo);


#ifdef NDEBUG
	char  szLibPath[_MAX_PATH]="patcher.dll";
#else
	char  szLibPath[_MAX_PATH]="C:\\Documents and Settings\\Gondos\\Mes documents\\Visual Studio 2008\\Projects\\UFOExtender\\Debug\\patcher.dll";
#endif

	pLibRemote = VirtualAllocEx( piProcessInfo.hProcess, NULL, sizeof(szLibPath), MEM_COMMIT, PAGE_READWRITE );
	WriteProcessMemory( piProcessInfo.hProcess, pLibRemote, (void*)szLibPath, sizeof(szLibPath), NULL );


	hThread = CreateRemoteThread( piProcessInfo.hProcess, NULL, 0,
				(LPTHREAD_START_ROUTINE )GetProcAddress(
				 GetModuleHandle(_T("Kernel32")), "LoadLibraryA"),
				 pLibRemote, 0, NULL );
	WaitForSingleObject( hThread, INFINITE );
	CloseHandle( hThread );
	VirtualFreeEx( piProcessInfo.hProcess, pLibRemote, sizeof(szLibPath),MEM_RELEASE );

	AllowSetForegroundWindow(piProcessInfo.dwProcessId);

	if(int cpu=INI_READ_INT("Mod","CPU Mask",0))
	{
		SetProcessAffinityMask(piProcessInfo.hProcess, cpu);
	}

	if(INI_READ_INT("Mod","High Priority",0))
	{
		SetPriorityClass(piProcessInfo.hProcess, ABOVE_NORMAL_PRIORITY_CLASS);
	}

	ResumeThread( piProcessInfo.hThread );

	DebugActiveProcess(piProcessInfo.dwProcessId);
	exitCode = DebugLoop();
	
	ClipCursor(NULL);

	ExitProcess(exitCode);
	
}


DWORD DebugLoop()
{
	BOOL loop = TRUE;
	DWORD exitCode = 0;
	char buf[256];
	BOOL crashed = FALSE;

	while(loop)
	{
		DEBUG_EVENT DebugEv;
		DWORD dwContinueStatus = DBG_CONTINUE; // exception continuation 

		WaitForDebugEvent(&DebugEv, INFINITE); 

		switch(DebugEv.dwDebugEventCode)
		{
			case EXCEPTION_DEBUG_EVENT:
				if(DebugEv.u.Exception.ExceptionRecord.ExceptionCode == EXCEPTION_BREAKPOINT)
					break;
					 
				dwContinueStatus = DBG_EXCEPTION_NOT_HANDLED;

				if (DebugEv.u.Exception.ExceptionRecord.ExceptionCode == EXCEPTION_ACCESS_VIOLATION)
				{
					sprintf(buf,"XCOM crashed at 0x%X with error 0x%X trying to access 0x%08X",DebugEv.u.Exception.ExceptionRecord.ExceptionAddress,DebugEv.u.Exception.ExceptionRecord.ExceptionCode,DebugEv.u.Exception.ExceptionRecord.ExceptionInformation[1]);
				}
				else
				{
					sprintf(buf,"XCOM crashed at 0x%X with error 0x%X",DebugEv.u.Exception.ExceptionRecord.ExceptionAddress,DebugEv.u.Exception.ExceptionRecord.ExceptionCode);
				}

				TerminateProcess(piProcessInfo.hProcess, 0);
				crashed = TRUE;
				break;
			case EXIT_PROCESS_DEBUG_EVENT:
				exitCode = DebugEv.u.ExitProcess.dwExitCode;
				loop = FALSE;
				break;
			case RIP_EVENT:
				sprintf(buf,"XCOM caught RIP EVENT!");
				crashed = TRUE;
				loop = FALSE;
				break;
			default:
				break;
		}

		ContinueDebugEvent(DebugEv.dwProcessId, 
						  DebugEv.dwThreadId, 
						  dwContinueStatus);

	}

	if(crashed)
	{
		MessageBox(NULL,buf,"Application failure",MB_ICONERROR);
	}

	return exitCode;
}
